#!/usr/bin/perl -w
#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: list.cgi,v 1.6 2004/09/18 01:08:01 fuktommy Exp $
#
use strict;
use lib qw(..);
use Shingetsu::Config;
use Shingetsu::Cache;
use Shingetsu::CacheStat;
use Shingetsu::Gateway;

umask $Shingetsu::Config::umask;

my $datadir	= $Shingetsu::Config::datadir;
my $cachedir	= $Shingetsu::Config::cachedir;
my $menufile	= $Shingetsu::Config::menufile;
my $root	= $Shingetsu::Config::root;
my @types	= qw(list thread note);
my $message	= $Shingetsu::Gateway::message;

#
# print list
#
sub printList($) {
	my($list) = @_;
	local $_;
	$list = escape($list);
	my $file_list = file_encode("list", $list);
	touch($file_list);
	open IN, "$cachedir/$file_list/body.cache"
			or open IN, "$datadir/$file_list.dat";
	printHeader($list);
	print "<form method='get' action='$ENV{SCRIPT_NAME}'>",
	      "<p><input type='hidden' name='cmd' value='delete' />",
	      "<input type='hidden' name='file' value='$file_list' />",
	      "</p><ul>\n";
	my @buf = ();
	my %stamp = ();
	my %stat = Shingetsu::CacheStat::list();
	my $count = 0;
	while (<IN>) {
		$count++;
		my %rec = rec($_);
		next if (keys %rec <= 2);
		$rec{body} = "" unless (defined $rec{body});
		my $stamp = $rec{stamp};
		my $buf;
		if ($rec{type}) {
			my $file_child = file_encode($rec{type}, $rec{link});
			my $file = "$datadir/$file_child.dat";
			my $records = 0;
			my $size    = 0;
			if (-s $file) {
				$stamp   = $stat{$file_child}{stamp};
				$records = $stat{$file_child}{records};
				$size	 = int($stat{$file_child}{size}/1024/1024*10)/10;
			}
			$records = "?" if ($records <= 0);
			my $str = xlocaltime($stamp);
			my $child = str_encode($rec{link});
			my $anchor = $rec{link};
			if ($rec{type} =~ /^(list|thread|note)$/) {
				$anchor = "<a href='${root}$rec{type}.cgi/$child'>$rec{link}</a>";
			}

			$buf = "<li><input type='radio' name='record' value='$rec{stamp}/$rec{id}' " .
			       "tabindex='1' accesskey='s' />" .
			       "$str $anchor" . 
			       "($$message{$rec{type}}/$records/$size$$message{mb})$rec{body}</li>\n";
		} elsif ($rec{remove_stamp}) {
			$stamp = $rec{remove_stamp};
			my $str = xlocaltime($stamp);
			my $check = "";
			$rec{name} = "" unless (defined $rec{name});
			if ($rec{sign}) {
				$check = "<a href='$ENV{SCRIPT_NAME}?cmd=check&amp;" .
					"file=" . file_encode("list", $list) . "&amp;" .
					"stamp=$rec{stamp}&amp;id=$rec{id}'>" .
					"$rec{pubkey}" . "[$rec{target}]</a>";
			}
			$buf = "<li><input type='radio' name='record' value='$rec{stamp}/$rec{id}' " .
			       "tabindex='1' accesskey='s' />" .
			       "$str: $rec{name} $check $$message{remove}: $rec{body}</li>\n";
		}
		push @buf, $buf;
		$stamp{$buf} = $stamp;
	}
	close IN;
	@buf = sort {$stamp{$b} <=> $stamp{$a}} @buf;
	print @buf;
	print "</ul><p><input type='submit' value='$$message{del_record}' tabindex='2' accesskey='d' />",
	      "<input type='hidden' name='mode' value='list' /></p></form>";
	my $filesize = int((-s "$datadir/$file_list.dat")/1024/1024*10)/10;
	my $checked = ($count)? "checked='checked'": "";
	if ($filesize <= $Shingetsu::Config::filelimit) {
		newElementForm(file=>$file_list, checked=>$checked, dopost=>1);
	}
	print "<form action='$ENV{SCRIPT_NAME}'>",
	      "<p><input type='submit' value='$$message{del_file}' tabindex='6' accesskey='d' />",
	      "<input type='hidden' name='cmd' value='delete' />",
	      "<input type='hidden' name='file' value='$file_list' />",
	      " ${filesize}$$message{mb}</p></form></body></html>\n";
}

#
# main routine
#
my ($path, $input) = readQuery();
my %arg = args($input);
my $cmd = ($arg{cmd})? $arg{cmd}: "";
my $file = ($arg{file})? $arg{file}: "";
my $record = ($arg{record})? $arg{record}: "";

if (($cmd eq "new") && ($file =~ /^list_[0-9A-F]+$/)) {
	newElement($file, %arg);
	print302("${root}list.cgi/" . str_encode(file_decode($arg{file})));

} elsif ($cmd eq "check") {
	checkSign(%arg);

} elsif ($cmd eq "delete") {
	checkAdmin();
	deleteDialog(%arg);

} elsif (($cmd eq "xdelete")
		&& ($ENV{HTTP_REFERER} =~ m{http://[^/]+/(list|thread|note)\.cgi\?cmd=delete})) {
	checkAdmin();
	if (! defined $arg{file}) {
		print404();
		exit;
	} elsif ((defined $arg{stamp})&&(defined $arg{id})) {
		deleteRecord($arg{file}, $arg{stamp}, $arg{id}, \%arg);
	} else {
		deleteFile($arg{file});
	}

} elsif ($path eq "") {
	printList($menufile);

} elsif ($path !~ m|/|) {
	printList($path);

} else {
	print404();
	exit;
}
